/*
 * Copyright (C) 2000, 2001, 2002, Amnon Barak (amnon@MOSIX.org)
 * Some sections copyright 2002 by Moshe Bar
 * Permission to use this software is hereby granted under the terms of the
 * GNU General Public License, as published by the Free Software Foundation.
 *
 * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
 * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
 * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
 */
/*
 * Author(s): Amnon Shiloh, Moshe Bar
 */

/*
 * Produce an include-file for "entry.S", with:
 * 1. constant-offsets of some required MOSIX-members of "task_struct"
 * 2. some bits to test "current->dflags"
 * 3. a duplicate system-call table (remote_sys_call_table), with all
 *    system-calls names preceded by a "remote_".
 */

#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/signal.h>
#include <linux/sched.h>
#include <linux/sys.h>

struct file;
#define FILE	struct file

extern int printf(char *, ...);
extern int fgets(char *, int, FILE *);
extern int perror(char *);
extern FILE *stdin;

char line[2048];

int
main(void)
{
	register char *c;
	long t, time(long *);
	char *ctime(long *);

	time(&t);
	printf("/* Please do not edit -- this file is created automatically */\n");
	printf("/* %.24s */\n\n", ctime(&t));
	printf("ALTREGS\t\t= 0x%X\n",
		(int)&(((struct task_struct *)0)->mosix.altregs));
	printf("DFLAGS\t\t= 0x%X\n",
		(int)&(((struct task_struct *)0)->mosix.dflags));
	printf("DDEPUTY\t\t= 0x%X\n", DDEPUTY);
	printf("DREMOTE\t\t= 0x%X\n", DREMOTE);
	printf("DTRACESYS1\t\t= 0x%X\n", DTRACESYS1);
	printf("DTRACESYS2\t\t= 0x%X\n", DTRACESYS2);
	printf(".data\n");
	printf("\nENTRY(remote_sys_call_table)\n");
	while(fgets(line, 2048, stdin) &&
		strcmp(line, "ENTRY(sys_call_table)\n"))
			;
	while(fgets(line, 2048, stdin))
	if(!strncmp(line, "\t.long SYMBOL_NAME(", 19))
	{
		for(c = &line[19] ; *c && *c != ')' ; c++);
		*c = '\0';
		if(!strcmp(&line[19], "sys_ni_syscall"))
		{
			printf("\t.long SYMBOL_NAME(sys_ni_syscall)\n");
			continue;
		}
		printf("\t.long SYMBOL_NAME(remote_%s)\n", &line[19]);
	}
	else if(!strcmp(line, "\t.rept NR_syscalls-(.-sys_call_table)/4\n"))
		printf("\t.rept NR_syscalls-(.-remote_sys_call_table)/4\n");
	else
	{
		printf("%s", line);
		if(!strncmp(line, "\t.endr", 5))
			break;
	}
	printf(".text\n");
	return(0);
}
